package eu.maiora.model

import eu.maiora.db.*
import org.jetbrains.exposed.sql.SortOrder
import org.jetbrains.exposed.sql.and
import java.time.LocalDate
import java.time.LocalDateTime
import java.time.format.DateTimeFormatter

class PuntiDistribuzioneRepositoryImpl : PuntiDistribuzioneRepository {
    override suspend fun puntiDistByGiornoIdTurno(giorno : String, idTurno : Long): List<PuntiDistribuzione> = suspendTransaction {
        // Cerca la lista di punti distribuzione dalla tabella degli slot prenotabili
        val formatter = DateTimeFormatter.ofPattern("ddMMyyyy")
        val formattedDate = LocalDate.parse(giorno, formatter)

        SlotPrenotabiliDao.find { (SlotPrenotabiliTable.giorno eq formattedDate) and (SlotPrenotabiliTable.idTurno eq idTurno)}
            .toList() // Restituisce la lista degli slot prenotabili da cui ricavare i punti distribuzione
            .map { puntiDistribuzioneDaoToModel(it) } // Converte il DAO in un oggetto PuntiDistribuzione

    }
}