package eu.maiora.model

import eu.maiora.db.*
import org.jetbrains.exposed.sql.SortOrder
import org.jetbrains.exposed.sql.insertAndGetId

class ViewPrenotazioniPastiRepositoryImpl : ViewPrenotazioniPastiRepository {

    override suspend fun prenotazioniPastiById(id : Long): ViewPrenotazioniPasti = suspendTransaction {
        // Cerca la prenotazione
        ViewPrenotazioniPastiDao.find { ViewPrenotazioniPastiTable.idPrenotazione eq id }
            .first() //prendo solo il primo record, dato che ci sono tanti record quanti prodotti prenotati
            .let { viewPrenotazioniPastiDaoToModel(it) } // Converte il DAO in un oggetto ViewPrenotazioniPasti
    }

    override suspend fun prenotazioniPastiByIdTessera(idTessera : Long): List<ViewPrenotazioniPasti> = suspendTransaction {
        // Cerca la lista di prenotazioni
        ViewPrenotazioniPastiDao.find { ViewPrenotazioniPastiTable.idTessera eq idTessera }
            .orderBy(ViewPrenotazioniPastiTable.giorno to SortOrder.DESC)
            .toList() // Restituisce la lista delle prenotazioni
            .map { viewPrenotazioniPastiDaoToModel(it) } // Converte il DAO in un oggetto Movimenti

    }
}